#include <iostream>

using namespace std;


class Super
{
public:
    // NON-VIRTUAL method
    void PrintNum()
    {
        cout << 1 << endl ;
    }
} ;

class Sub : public Super
{
public:
    // Override
    void PrintNum()
    {
        cout << 2 << endl ;
    }
} ;

class SuperVirtual
{
public:
    // NOW IT IS VIRTUAL
    virtual void PrintNum()
    {
        cout << 1 << endl ;
    }
} ;

class SubVirtual : public SuperVirtual
{
public:
    // Override. Keep virtual in case this gets
    // inherited again.
    virtual void PrintNum()
    {
        cout << 2 << endl ;
    }
} ;

// Note pass by reference
void test_print(SuperVirtual &sP)
{
    sP.PrintNum() ;
}

// Note pass by reference
void test_print(Super &sP)
{
    sP.PrintNum() ;
}


int main()
{
    cout << "" ;
    Super sP ;
    test_print(sP) ;  // Prints 1
    Sub sB ;
    test_print(sB) ;  // Hey!! Prints 1!!

    SuperVirtual x ;
    // Which Func is called?
    test_print(x) ;  // Prints 1
    SubVirtual y ;
    test_print(y) ; //  Prints 2


    return 0;
}
